<style scoped="">
.text_slider_items_ct{
  display: flex;
  justify-content: center;
}
.text_slider_pointer_item{
  height: 3px;
  width: 100px;
  background-color: #B6B6C9;
  background-color: rgba(255, 255, 255, 0.3);
  cursor: pointer;
}
.text_slider_pointer_item:hover{
  background-color: #8181a5;
}
.text_slider_pointer_item_selected:hover, .text_slider_pointer_item_selected{
  background-color: #0D5EE5;
  background-color: #fff;
}
.text_slider_text_ct{
  padding-bottom: 28px;
}
.text_slider_text{
  display: none;
  font-size: 20px;
  line-height: 1;
  color: rgba(53, 53, 86, 0.5803921568627451);
  text-align: center;
}
.text_slider_text_show{
  display: block;
}
@media (max-width: 800px) {
  .text_slider_pointer_item{
    width: 45px;
  }
  .text_slider_text{
    font-size: 12px;
  }
}
</style>
<template>
 <div class="text_slider_ct" @mouseover="action_hover" @mouseout="stop_hover">
    <div class="text_slider_text_ct">

     <!--  <div class="text_slider_text text_slider_text_show">
        一票一投  每一票仅能投给一个节点
      </div>
      <div class="text_slider_text">
        投票分红  参与投票可获得收益
      </div>
      <div class="text_slider_text">
        时间加权  抵押时间越长，投票权重越高
      </div>
      <div class="text_slider_text">
        预算系统  负责审批社区的预算提案申请
      </div> -->

      <div class="text_slider_text" v-for="item, index in data" v-bind:class="{'text_slider_text_show': index == focus_index}" v-if="show_text">
        {{ item }}
      </div>

    </div>
    <div class="text_slider_items_ct" v-if="!hide_bar">
      <!-- <div class="text_slider_pointer_item text_slider_pointer_item_selected"></div>
      <div class="text_slider_pointer_item"></div>
      <div class="text_slider_pointer_item"></div> -->
      <div class="text_slider_pointer_item" v-bind:style="item.item_style"  v-for="item, index in data" v-bind:class="{'text_slider_pointer_item_selected': index == focus_index}" @click="change_focus_index(index)"></div>
    </div>
  </div>
</template>
<script>
import { wait_time } from '../modules/utils'
export default {
  data () {
    return {
      focus_index: 0,
      is_hover: false
    }
  },

  props: {
    data: {
      type: Array,
      default () {
        return []
      }
    },
    hover: {
      type: Boolean,
      default () {
        return false;
      }
    },
    show_text: {
      type: Boolean,
      default () {
        return false;
      }
    },
    value: {
      type: Number,
      default () {
        return 0;
      }
    },
    hide_bar: {
      type: Boolean,
      default () {
        return false;
      }
    },
    wait_time: {
      type: Number,
      default () {
        return 5;
      }
    },
    step_change: {
      type: Number,
      default () {
        return 0;
      }
    }
  },

  watch: {
    'hover' (cur_val, pre_val) {
      this.is_hover = cur_val;
    },
    'step_change' (val) {
      this.change_focus(val > 0 ? 1 : -1);
    }
  },

  mounted () {
    this.start_change();
  },

  methods: {
    async start_change () {
      while(1){
        await wait_time(this.wait_time);
        if(this.is_hover) continue;
        this.change_focus();
      }
    },
    change_focus (step = 1) {
      let max = this.data.length;
      let next = this.focus_index + step;
      next = next >= max ? 0 : next;
      next = next < 0 ? max - 1 : next;
      this.focus_index = next;
      this.$emit('input', this.focus_index);
    },
    action_hover () {
      this.is_hover = true;
    },
    stop_hover () {
      this.is_hover = false;
    },
    change_focus_index (index) {
      this.focus_index = index;
      this.$emit('input', this.focus_index);
    }
  }
}
</script>




